﻿package {
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.KeyboardEvent;
	import flash.events.TimerEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.utils.Timer;
	import info.kazushi.ClientEvent;
	import org.as3s.Document;
	import info.kazushi.Client;
	
	/**
	* ...
	* @author Kazushi Mukaiyama
	*/
	public class Main extends Document {
		
		private var client:Client;
		
		public function Main() {
			trace("start");
			
			init();
			addEvents();
		}
		
		private function init():void
		{
			// 全クリップ停止
			for(var i:int=0; i<numChildren; i++){
				var mc:* = getChildAt(i);
				if(mc is MovieClip){
					mc.stop();
					trace("stop: ", mc.name);
				}
			}
			
			client = new Client("audio1");
			clientName.text = client.name;
			
			loadPreference();
		}
		
		private function addEvents():void
		{
			client.addEventListener(ClientEvent.AUTHORIZED, authorized);
			client.addEventListener(ClientEvent.RECIEVED, recieve);
			client.addEventListener(ClientEvent.RECONNECTING, reconnecting);
			client.addEventListener(ClientEvent.ERROR, error);

			loginButton.addEventListener(MouseEvent.CLICK, buttonClick);
			playA_Button.addEventListener(MouseEvent.CLICK, buttonClick);
			playB_Button.addEventListener(MouseEvent.CLICK, buttonClick);
		}
		
		private function loadPreference():void
		{
			// 外部ファイルからパラメータ読み込み
			var request:URLRequest = new URLRequest("data.xml");
			var loader:URLLoader = new URLLoader();
			loader.addEventListener(Event.COMPLETE, completeHandler);
			try
			{
				loader.load(request);
			}
			catch (error:ArgumentError)
			{
				showLog("An ArgumentError has occurred.");
			}
			catch (error:SecurityError)
			{
				showLog("A SecurityError has occurred.");
			}
		}
		
		private function completeHandler(event:Event):void
		{
			var dataXML:XML = XML(event.target.data);
			trace(dataXML.toXMLString());
			client.host = dataXML.@host;
			client.port = dataXML.@port;
			if (dataXML.@autoconnect == "true")
			{
				client.autoConnect = true;
			} else {
				client.autoConnect = false;
			}
			client.retryCount = int(dataXML.@retry);

			if (client.autoConnect) login();			
		}

		private function buttonClick(e:MouseEvent):void
		{
			//trace("Button Pressed: "+String.fromCharCode(e.charCode) +" (character code: "+e.charCode+")");
            var b:Button = e.target as Button;
			showLog(b.label + " pushed\n");
			var command:String = b.label;
			switch(command) {
				case "login":
					login();
					break;
				case "play A part":
					playA();
					break;
				case "play B part":
					playB();
					break;
				default:
					break;
			}
		}
		
		private function login():void {
			if (!client.authorized) {
				showLog("[login]: connecting..." + "\n");
				client.login();
			} else {
				showLog("[login]: this is online" + "\n");
			}
		}
		
		private function logout():void {
			if (client.authorized) {
				showLog("[login]: disconnecting..." + "\n");
			} else {
				showLog("[login]: this is offline" + "\n");
			}
		}
		
		private function playA():void {
			if (client.authorized) {
				showLog("play A..." + "\n");
				var data:XML = <client name={client.name} command='play_a' />;
				client.send(data.toXMLString()); //整形のため
			}
		}
		
		private function playB():void {
			if (client.authorized) {
				showLog("play B..." + "\n");
				var data:XML = <client name={client.name} command='play_b' />;
				client.send(data.toXMLString()); //整形のため
			}
		}
		
		private function authorized(e:ClientEvent):void {
			showLog("[recieve]: "+e.data + "\n");
			if (client.authorized)
			{
				showLog("[login]: connected" + "\n");
				//loginButton.text = "logout";
			}
		}
		
		private function recieve(e:ClientEvent):void {
			showLog("[recieve]: "+e.data + "\n");
		}
		
		private function reconnecting(e:ClientEvent):void {
			showLog("[reconnecting]: "+e.data + "\n");
		}
		
		private function error(e:ClientEvent):void {
			showLog("[error]: " + e.data + "\n");
		}
		
		private function showLog(str:String):void {
			logArea.appendText(str);
			logArea.verticalScrollPosition = logArea.textHeight;
		}
	}
}