package info.kazushi.io;

/**
 * Class: FileOut
 * @author: made     by Kazushi Mukaiyama <kazu@arizona.ne.jp>    1999/12/19
 *
 */

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.util.zip.GZIPOutputStream;

public class FileOut {
	ObjectOutputStream out; 
public void close() {
	try {
		out.close();
	} catch (IOException e) {
		System.out.println("Stream close error: " + e);
	}
}
public void open(String dirName, String fileName) {
	try {
		File f = new File(dirName + fileName);
		FileOutputStream fos = new FileOutputStream(f);
		GZIPOutputStream gzos = new GZIPOutputStream(fos);
		out = new ObjectOutputStream(gzos);
	} catch (IOException e) {
		System.out.println("File write error: " + e);
	}
}
public void write(Object data) {
	try {
		out.writeObject(data);
		out.flush();
	} catch (IOException e) {
		System.out.println("Stream write error: " + e);
	}
}
}
