package info.kazushi.net.server;

/**
 * Class: MeijiServer
 * @author: made     by Kazushi Mukaiyama <i@kazushi.info>    2008/05/05
 *
 */

import info.kazushi.net.server.clientDispacher.ClientDispatcher;

import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Menu;
import java.awt.MenuBar;
import java.awt.Panel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Hashtable;
import java.util.Iterator;


public class XMLServer {
	public static Hashtable<Integer, ClientDispatcher> clients = new Hashtable<Integer, ClientDispatcher>(); // arrey for ClientDispatcher

	ServerSocket server_socket = null;
	Socket client_socket = null;

	public LogArea systemMessage, recieveLog, sendLog;
	private Button[] clientButton;
	
	private Frame mainFrame;
	private Frame recieveWindow, sendWindow;
	private Panel clientPanel;
	private boolean gui = true;

	class StatusChecker extends Thread {
		public void run(){
			while(true){
				checkClientListStaus();
				try{sleep(5000);}catch(Exception e){}
			}
		}
		
		private void checkClientListStaus() {
			//{^It
			for(int i = 0; i < Protocol.MAX_CONNECTIONS; i++){
				clientButton[i].setLabel("-");
				clientButton[i].setEnabled(false);
			}
			
			//Y{^I
			Iterator<ClientDispatcher> cit = clients.values().iterator();
			while (cit.hasNext())
			{
				try {
					ClientDispatcher c = cit.next();
					if(c != null){
						clientButton[c.id].setLabel(String.valueOf(c.id));
						if(c.isAlive()) { // may be change for future
							clientButton[c.id].setEnabled(true);
						}
					}
				} catch (ClassCastException cce) {
					//System.out.println("Ops!");
				}
			}
		}
	}
	
	class EventManager implements ActionListener, WindowListener{
		public void actionPerformed(ActionEvent e) {
			//System.out.println(e.paramString());
			String cmd = e.getActionCommand();
			
			try {
				//ꂽNCAg{^̏\
				int i = Integer.parseInt(cmd);
				if (i >=0 && i < Protocol.MAX_CONNECTIONS) {
					ClientDispatcher c = clients.get(new Integer(i));
					StringBuffer sbuf = new StringBuffer();
					if(c != null){
						sbuf.append("\tsocket    : "+c.socket.toString()+"\n");
						sbuf.append("\tname      : "+c.name+"\n");
						sbuf.append("\taddress   : "+c.address+"\n");
					} else {
						sbuf.append(i+": data null\n\n");
					}
					systemMessage.append(sbuf.toString());
				}
			} catch(NumberFormatException ne){
				//{^ԍȊÕR}h
				if (cmd.equals("Quit")) {
					disconnectAll();
					mainFrame.dispose();
					System.exit(0);
				} else 
				if (cmd.equals("Receive Window")) {
					recieveWindow.setVisible(true);
				} else 
				if (cmd.equals("Send Window")) {
					sendWindow.setVisible(true);
				}
			}
		}
		public void windowOpened(WindowEvent e){}
		public void windowClosing(WindowEvent e){
			Frame f = (Frame)e.getWindow();
			f.dispose();
			if(f==mainFrame){System.exit(0);}
		}
		public void windowClosed(WindowEvent e){}
		public void windowActivated(WindowEvent e){}
		public void windowDeactivated(WindowEvent e){}
		public void windowIconified(WindowEvent e){}
		public void windowDeiconified(WindowEvent e){}
	}
	
	public static void main(java.lang.String[] args) {
		XMLServer server = new XMLServer();
		
		/* check arguments */
		for (int j = 0; j < args.length; j++) {
			if (args[j].equals("-nogui")) {
				server.setVisibleGUI(false);
			}
			if (args[j].equals("-h") || args[j].equals("-?")) {
				System.out.println("XMLSever [-h]");
				System.out.println("XMLSever [-nogui]");
				System.exit(0);
			}
		}
	
		server.initGUI();
		server.init();
		server.start();
	}
	
	private void init() {
		if(gui){
			systemMessage.append(
			"max users: "+ Protocol.MAX_CONNECTIONS + " " +
			"\n"
			);
		}else{
			System.out.print(
			"max users: "+ Protocol.MAX_CONNECTIONS + " " +
			"\n"
			);
		}
			
		/* status checker start */
		if(gui){
			StatusChecker checker = new StatusChecker();
			checker.start();
		}
	}
	
	private void initGUI() {
		if(gui){
			EventManager manager = new EventManager();
	
			mainFrame = new Frame("XML Server");
			mainFrame.setLayout(new BorderLayout());
			mainFrame.setBounds(0, 0, 500, 400);
			mainFrame.addWindowListener(manager);
		
				MenuBar mainMenu = new MenuBar();
					Menu main = new Menu("Main", true);
					main.add("Quit");
					main.addActionListener(manager);
					Menu window = new Menu("Window", true);
					window.add("Receive Window");
					window.add("Send Window");
					window.addActionListener(manager);
				mainMenu.add(main);
				mainMenu.add(window);
			mainFrame.setMenuBar(mainMenu);
	
				Panel base = new Panel();
				base.setLayout(new GridLayout(2,1));
			mainFrame.add("Center", base);
		
					int cleint_number = Protocol.MAX_CONNECTIONS;
					clientPanel = new Panel();
					clientPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
						Label clientL = new Label("Clients");
					clientPanel.add(clientL);
						clientButton = new Button[cleint_number];
						for(int i = 0; i < cleint_number; i++){
							clientButton[i] = new Button("-");
							clientButton[i].setSize(10,10);
							clientButton[i].setEnabled(false);
							clientButton[i].addActionListener(manager);
							clientPanel.add(clientButton[i]);
						}
				base.add(clientPanel);
					
					systemMessage = new LogArea(5,24);
					systemMessage.setEditable(false);
				base.add(systemMessage);
		
				/* other windows */
				recieveWindow = new Frame("Recieve Log");
				recieveWindow.setLayout(new BorderLayout());
				recieveWindow.addWindowListener(manager);
					recieveLog = new LogArea();
					recieveLog.setBounds(0, 0, 320, 240);
					recieveLog.setEditable(false);
				recieveWindow.add("Center", recieveLog);
				recieveWindow.pack();
			
				sendWindow = new Frame("Send Log");
				sendWindow.setLayout(new BorderLayout());
				sendWindow.addWindowListener(manager);
					sendLog = new LogArea();
					sendLog.setBounds(0, 0, 320, 240);
					sendLog.setEditable(false);
				sendWindow.add("Center", sendLog);
				sendWindow.pack();
	
			//mainFrame.pack();
			mainFrame.setVisible(true);
		}
	}

	private void start() {
		/* establish server socket */
		if(gui){
			systemMessage.append("Server start.\n");
		}else{
			System.out.print("Server start.\n");
		}
	
		try {
			server_socket = new ServerSocket(Protocol.PORT);
		} catch (IOException e) {
			if(gui){
				systemMessage.append("Could not create socket on: " + Protocol.PORT + ", " + e + "\n");
			}else{
				System.out.print("Could not create socket on: " + Protocol.PORT + ", " + e + "\n");
			}
			System.exit(1);
		}
		
		if(gui){
			systemMessage.append("Waiting for client connection...\n");
		}else{
			System.out.print("Waiting for client connection...\n");
		}
		
		while (true) {
			// accept client's connect request
			try {
				client_socket = server_socket.accept(); // loop blocking here!
			} catch (IOException e) {
				if(gui){
					systemMessage.append("Accept failed: " + Protocol.PORT + ", " + e + "\n");
				}else{
					System.out.print("Accept failed: " + Protocol.PORT + ", " + e + "\n");
				}
				System.exit(1);
			}
			
			// make this client dispatch thread
			if(clients.size() >= Protocol.MAX_CONNECTIONS) {
				try{
					BufferedReader b_in = new BufferedReader(new InputStreamReader(client_socket.getInputStream(), Protocol.ENCODING));
					PrintWriter   b_out = new PrintWriter(new OutputStreamWriter(client_socket.getOutputStream(), Protocol.ENCODING), true);
					b_in.readLine();
					b_out.write("RFUS:Connection refused to "+client_socket.getInetAddress().getHostName()+": max connection reached.\r\n");
					b_out.flush();
					client_socket.close();
					if(gui){
						systemMessage.append("Connection refused to " + client_socket.getInetAddress().getHostName() +
						": max connection reached.\n");
					}else{
						System.out.print("Connection refused to " + client_socket.getInetAddress().getHostName() +
						": max connection reached.\n");
					}
				} catch (IOException e) {
					if(gui){
						systemMessage.append("Refuse notification error: " + e + "\n");
					}else{
						System.out.print("Refuse notification error: " + e + "\n");
					}
				}
			} else {
				int id = 0;
				while (true) {
					Integer ID = new Integer(id);
					if (!clients.containsKey(ID)) {
						clients.put(ID, new ClientDispatcher(client_socket, id, this));
						if(gui){
							systemMessage.append("Connection established: " + client_socket.getInetAddress().getHostName() + ": ID=" + id + "\n");
						}else{
							System.out.print("Connection established: " + client_socket.getInetAddress().getHostName() + ": ID=" + id + "\n");
						}
						break;
					}
					id++;
				}
			}
		}
	}
	
	public synchronized void sendDataToClients(String d, int id) {
		Iterator<ClientDispatcher> cit = clients.values().iterator();
		while (cit.hasNext())
		{
			try {
				ClientDispatcher c = cit.next();
				//if(c.id != id) 
					c.send(d);
			} catch (ClassCastException cce) {
				//System.out.println("Ops!");
			}
		}
	}
	
	public synchronized void disconnect(ClientDispatcher c) {
		try {
			c.socket.close();
			if(gui){
				systemMessage.append("Disconnect: " + c.socket.getInetAddress().getHostName() + ": ID=" + c.id + "\n");
			} else {
				System.out.print("Disconnect: " + c.socket.getInetAddress().getHostName() + ": ID=" + c.id + "\n");
			}	
		} catch (IOException e) {
			if(gui){
				systemMessage.append("Disconnection Error: " + e + "\n");
			} else {
				System.out.print("Disconnection Error: " + e + "\n");
			}	
		} finally {
			clients.remove(new Integer(c.id));
			if(gui){
				systemMessage.append("Removed on list: " + c.socket.getInetAddress().getHostName() + ": ID=" + c.id + "\n");
			} else {
				System.out.print("Removed on list: " + c.socket.getInetAddress().getHostName() + ": ID=" + c.id + "\n");
			}	
		}
	}
	
	public synchronized void disconnectAll() {
		Iterator<ClientDispatcher> cit = clients.values().iterator();
		while (cit.hasNext())
		{
			ClientDispatcher c = cit.next();
			disconnect(c);
		}
		clients.clear();
	}
	
	public boolean getVisibleGUI() {
		return gui;
	}
	
	public void setVisibleGUI(boolean b) {
		gui = b;
	}
	
}
